;--------------------------------------------------------------------------
;   16C5X.ASM
;
;   Opcode test for the SB-Assembler 16C5x cross
;
;--------------------------------------------------------------------------

                .CR     16C5X    And now for something completely different

FILE            .EQ     $12             A legal file address
BIT             .EQ     3               Just an arbitrary bit number
PORTA           .EQ     $05             f value for port A
                .MS     $200            Maximum memory size (512 words)

;--------------------------------------------------------------------------
;   Immediate instructions
;--------------------------------------------------------------------------

                ANDLW   #$12
                IORLW   #$12
                MOVLW   #$12
                RETLW   #$12,#$34,#$56  Multiple operands allowed only here
                XORLW   #$12

;--------------------------------------------------------------------------
;   W and file related instructions
;--------------------------------------------------------------------------

                ADDWF   FILE,W
                ADDWF   FILE,F
                ADDWF   FILE            Omitted destination = destination F
                ANDWF   FILE,W
                ANDWF   FILE,F
                ANDWF   FILE
                COMF    FILE,W
                COMF    FILE,F
                COMF    FILE
                DECF    FILE,W
                DECF    FILE,F
                DECF    FILE
                DECFSZ  FILE,W
                DECFSZ  FILE,F
                DECFSZ  FILE
                INCF    FILE,W
                INCF    FILE,F
                INCF    FILE
                INCFSZ  FILE,W
                INCFSZ  FILE,F
                INCFSZ  FILE
                IORWF   FILE,W
                IORWF   FILE,F
                IORWF   FILE
                MOVF    FILE,W
                MOVF    FILE,F
                MOVF    FILE
                RLF     FILE,W
                RLF     FILE,F
                RLF     FILE
                RRF     FILE,W
                RRF     FILE,F
                RRF     FILE
                SUBWF   FILE,W
                SUBWF   FILE,F
                SUBWF   FILE
                SWAPF   FILE,W
                SWAPF   FILE,F
                SWAPF   FILE
                XORWF   FILE,W
                XORWF   FILE,F
                XORWF   FILE

;--------------------------------------------------------------------------
;   File only instructions
;--------------------------------------------------------------------------

                CLRF    FILE            (Mchip doc mistakenly specifies d)
                MOVWF   FILE
                TRIS    $07             Only 5, 6 and 7 is allowed
                TRIS    PORTA           Labels values are also accepted

;--------------------------------------------------------------------------
;   BIT instructions
;--------------------------------------------------------------------------

                BCF     FILE,BIT
                BSF     FILE,BIT
                BTFSC   FILE,BIT
                BTFSS   FILE,BIT

;--------------------------------------------------------------------------
;   JUMP instructions
;--------------------------------------------------------------------------

                CALL    THERE
                GOTO    THERE

;--------------------------------------------------------------------------
;   Implied instructions
;--------------------------------------------------------------------------

THERE           CLRW
                CLRWDT
                NOP
                OPTION
                SLEEP

;--------------------------------------------------------------------------
;   Adapted directives
;--------------------------------------------------------------------------

                .AS     /Test/          All generated data is translated
                .AT     /Test/           to RETLW instructions
                .AZ     /Test/

                .DA     #$1234,/$1234,$1234
                .DR     #$1234,/$1234,$1234

                .HS     .12.34.56.78

                .RF     $10

                .BS     $10,$FF         Fill bytes translated to RETLW $FF

                .NO     $100,$00        Fill bytes translated to RETLW $00

;--------------------------------------------------------------------------
;   Reset vector at last program memory location
;--------------------------------------------------------------------------

                .OR     $01FF
                GOTO    0               Or any other location in first page

;--------------------------------------------------------------------------
;   ID and CW are located outside program memory
;--------------------------------------------------------------------------

                .OR     $0200           ID word directly after program mem.

                .ID     $1234           Fill ID word

                .OR     $0FFF           Standard configuratio word location
                .CW     XT,WDTE,CP      Specify configuration word

