;--------------------------------------------------------------------------
;   16CXXX.ASM
;
;   Opcode test for the SB-Assembler 16Cxxx cross
;
;--------------------------------------------------------------------------

                .CR     16CXXX   And now for something completely different

FILE            .EQ     $12             A legal file address
BIT             .EQ     3               Just an arbitrary bit number
                .MS     $400            Set maximum memory size to 1k words

;--------------------------------------------------------------------------
;   Immediate instructions
;--------------------------------------------------------------------------

                ADDLW   #$12
                ANDLW   #$12
                IORLW   #$12
                MOVLW   #$12
                RETLW   #$12,#$34,#$56  Multiple operands allowed only here
                SUBLW   #$12
                XORLW   #$12

;--------------------------------------------------------------------------
;   W and file related instructions
;--------------------------------------------------------------------------

                ADDWF   FILE,W
                ADDWF   FILE,F
                ADDWF   FILE            Omitted destination = destination F
                ANDWF   FILE,W
                ANDWF   FILE,F
                ANDWF   FILE
                COMF    FILE,W
                COMF    FILE,F
                COMF    FILE
                DECF    FILE,W
                DECF    FILE,F
                DECF    FILE
                DECFSZ  FILE,W
                DECFSZ  FILE,F
                DECFSZ  FILE
                INCF    FILE,W
                INCF    FILE,F
                INCF    FILE
                INCFSZ  FILE,W
                INCFSZ  FILE,F
                INCFSZ  FILE
                IORWF   FILE,W
                IORWF   FILE,F
                IORWF   FILE
                MOVF    FILE,W
                MOVF    FILE,F
                MOVF    FILE
                RLF     FILE,W
                RLF     FILE,F
                RLF     FILE
                RRF     FILE,W
                RRF     FILE,F
                RRF     FILE
                SUBWF   FILE,W
                SUBWF   FILE,F
                SUBWF   FILE
                SWAPF   FILE,W
                SWAPF   FILE,F
                SWAPF   FILE
                XORWF   FILE,W
                XORWF   FILE,F
                XORWF   FILE

;--------------------------------------------------------------------------
;   File only instructions
;--------------------------------------------------------------------------

                CLRF    FILE
                MOVWF   FILE
                TRIS    $07             Only 5, 6 and 7 is allowed
; NOTE: TRIS is discouraged by Microchip, use the TRIS registers instead

;--------------------------------------------------------------------------
;   BIT instructions
;--------------------------------------------------------------------------

                BCF     FILE,BIT
                BSF     FILE,BIT
                BTFSC   FILE,BIT
                BTFSS   FILE,BIT

;--------------------------------------------------------------------------
;   JUMP instructions
;--------------------------------------------------------------------------

                CALL    THERE
                GOTO    THERE

;--------------------------------------------------------------------------
;   Implied instructions
;--------------------------------------------------------------------------

THERE           CLRW
                CLRWDT
                NOP
                OPTION
                RETFIE
                RETURN
                SLEEP
; NOTE: OPTION is discouraged by Microchip, use the OPTION register instead

;--------------------------------------------------------------------------
;   Adapted directives used in program memory
;--------------------------------------------------------------------------

                .AS     /Test/          All generated data is translated
                .AT     /Test/           to RETLW instructions
                .AZ     /Test/

                .DA     #$1234,/$1234,$1234
                .DA     #$12345678
                .DA     /$12345678
                .DA     =$12345678
                .DA     \$12345678
                .DR     #$1234,/$1234,$1234

                .HS     .12.34.56.78

                .RF     $10

                .OT                     Open table (.CT must be on same page)
                .BS     $10,$FF         Words are filled with 14bit data
                .CT                     Must be on same page as .CT

                .NO     $100,$FF        New ORG and fill skipped words

;--------------------------------------------------------------------------
;   Adapted directives used in data memory
;--------------------------------------------------------------------------

                .OR     $2000                Standard ID word location
                .ID     $1234                Fill ID word

                .OR     $2007                Standard config word location
                .CW     XT,PWRTE,CP,WDTE     Specify configuration word

                .OR     $2100                Default data memory address
                .DA     #$1234,/$1234,$1234  Data is stored in words with
                .DA     #$12345678            high bytes beeing $00
                .DA     /$12345678
                .DA     =$12345678
                .DA     \$12345678
                .DR     #$1234,/$1234,$1234

                .RF     $10

; The directives .BI .EP and .PH are not allowed with the PIC cross
