;------------------------------------------------------------------------
;   SFR8052.ASM
;
;   Include file declaring all standard 8052 SFRs
;
;------------------------------------------------------------------------

P0      .EQ     $80             I/O Port 0
SP      .EQ     $81             Stack pointer
DPL     .EQ     $82             LSB of DPTR
DPH     .EQ     $83             MSB of DPTR
PCON    .EQ     $87             Power control register

TCON    .EQ     $88             Timer control
TMOD    .EQ     $89             Timer mode register
TL0     .EQ     $8A             LSB of timer 0
TL1     .EQ     $8B             LSB of timer 1
TH0     .EQ     $8C             MSB of timer 0
TH1     .EQ     $8D             MSB of timer 1

P1      .EQ     $90             I/O port 1

SCON    .EQ     $98             Serial I/O control
SBUF    .EQ     $99             Serial I/O transfer buffer

P2      .EQ     $A0             I/O port 2

IE      .EQ     $A8             Interrupt Enable bits

P3      .EQ     $B0             I/O port 3

IP      .EQ     $B8             Interrupt Priority bits

T2CON   .EQ     $C8             Timer 2 control
RCAP2L  .EQ     $CA             LSB of timer 2 capture register
RCAP2H  .EQ     $CB             MSB of timer 2 capture register
TL2     .EQ     $CC             LSB of timer 2
TH2     .EQ     $CD             MSB of timer 2

PSW     .EQ     $D0             Program status word

ACC     .EQ     $E0             Accumulator A

B       .EQ     $F0             Accumulator B

;------------------------------------------------------------------------
;   PSW bit names
;------------------------------------------------------------------------

P       .EQ     $D0             Parity bit
F1      .EQ     $D1             User definable flag 1
OV      .EQ     $D2             Overflow flag
RS0     .EQ     $D3             Register bank select LSB
RS1     .EQ     $D4             Register bank select MSB
F0      .EQ     $D5             User definable flag 1
AC      .EQ     $D6             Auxiliary flag
CY      .EQ     $D7             Carry flag

